﻿try (destroyDialog rolMainRR) catch()
global DialogIniFile = getDir #plugcfg + "/RegionRenderSaveDialogRoll_Pos.ini"
if renderSceneDialog.isOpen() == true do messagebox "The Render Dialog needs to close and say closed for any changes to take effect.\n\n\nYou don't really need it for test rendering anyway (◣_◢)\n\nIf you open the render dialog and make changes, click the 'U!' button to update the UI." title:"RegionRender V2.0 by 3dwannab (◣_◢)"  beep:true
if renderSceneDialog.isOpen() == true do renderSceneDialog.close()
--------------------------------------------------------------------------------
rollout rolMainRR "RegionRender V2.0 by 3dwannab (◣_◢)"
(
	on rolMainRR moved pos do
	(
	setIniSetting DialogIniFile "RegionRenderSaveDialogRoll" "Position" (pos as string)
	)
    subRollout scriptBin width:252 height:268 pos:[-1,-1]
--------------------------------------------------------------------------------
    rollout rolSub_1 "Settings" width:252 height:254
		
    (
    	checkbutton chk_region "Region" pos:[8,32] width:76 height:20 toolTip:"Toggle Region ON/OFF"
		checkbutton chk_blowup "Blowup" pos:[8,52] width:76 height:20 toolTip:"Toggle Blowup ON/OFF"
    	checkbutton chk_displacement "Displace" pos:[84,32] width:72 height:20 toolTip:"Toggle Displacement ON/OFF\n\nHelpful to speed up test renders when you're in an area where there is no displacement and don't need to parse the scene."
    	button btn_Render "RENDER" pos:[156,32] width:76 height:40 toolTip:"Start Render"

		spinner spn_output_width "" pos:[48,96] width:56 height:16 range:[2,32768,1] type:#integer scale:1 toolTip:"Output width (px)"
    	spinner spn_output_height "" pos:[136,96] width:56 height:16 range:[2,32768,1] type:#integer scale:1 toolTip:"Output height (px)"
    	spinner spn_giaa "" pos:[48,120] width:56 height:16 range:[1,1024,16] type:#integer scale:1 toolTip:"Sampling balance: GI/AA\n\nThe amount of GI samples per each Anti-Aliasing sample.\n\nHigher values will increase sampling of Global Illumination, resulting in cleaner indirect lighting, glossy reflections, refractions and translucency. Lower values will increase sampling of Anti-Aliasing and therefore improve quality of fine geometry edges, Depth of Field, and Motion Blur.\n\nSetting this value under 2 or above 64 is not recommended.\n\nDEFAULT: 16"
    	spinner spn_lsm "" pos:[48,144] width:56 height:16 range:[0.0001,100,2] type:#float toolTip:"Sampling balance: Light samples multiplier\n\nThe amount of direct lights samples per each GI sample.\n\nIncrease this value in scenes where there is visible noise in the direct lighting. Default value of 2.0 works well in most cases.\n\nDEFAULT: 2.0"
    	spinner spn_msi "" pos:[136,120] width:56 height:16 range:[0,1000,20] type:#float scale:0.01 toolTip:"Speed/Accuracy balance: Max sample intensity\n\nThe ratio between rendering performance and physical accuracy.\n\nLowering it will result in clamping of the reflection and refraction caustics brightness, significantly reducing noise at the expense of bias. Increasing this value will reduce amount of clamping but also increase amount of noise. Default value of 20 works well in most scenes.\n\nSetting this value to 0 enables special unbiased mode where no clamping will occur. This mode will however often introduce fireflies that may never converge when using Progressive or Bucket render engine.\n\nDEFAULT: 20.0"
    	spinner spn_mrd "" pos:[136,144] width:56 height:16 range:[1,100,25] type:#integer scale:10 toolTip:"Speed/Accuracy balance: Max ray depth\n\nThe maximum possible number of light bounces.\n\nLowering this value slightly improves performance, increasing it slightly improves accuracy. The change in Corona is however very small compared to other renderer's, so keeping the default value is advised.\n\nDEFAULT: 25"
		spinner spn_pass_limit "" pos:[136,168] width:56 height:16 range:[0,1000,50] type:#integer scale:10 toolTip:"The number of passes after which the rendering will stop. Each pass performs one anti-aliasing sample per pixel and a variable amount of secondary samples set by the GI/AA balance parameter.\n\nDEFAULT 0 = Infinity"
	
		button btn_res_width_mul "x" pos:[8,72] width:76 height:16 toolTip:"Width resolution:\n\nx 2 = Left click\n/ 2 = Right click"
    	button btn_res_height_mul "x" pos:[156,72] width:76 height:16 toolTip:"Height resolution:\n\nx 2 = Left click\n/ 2 = Right click"
		button btn_res_overall_mul "x" pos:[112,96] width:16 height:16 toolTip:"Overall resolution:\n\nx 2 = Left click\n/ 2 = Right click"
		
		button btn_about "(◣_◢)" pos:[84,72] width:72 height:16 toolTip:"About"

    	button btn_render_setup_dialog "S" pos:[112,120] width:16 height:16 toolTip:"Left click: Open Render Setup\n\nRight click: Close Render Setup"
    	button btn_update_ui "U!" pos:[112,144] width:16 height:16 toolTip:"Click here to update UI from render dialog settings"
    	button btn_render_resume "Resume" pos:[84,52] width:72 height:20 toolTip:"Resume Last Render"
		
    	label lb_output_width "W px:" pos:[8,96] width:32 height:16
    	label lb_output_height ":H px" pos:[200,96] width:32 height:16
		label lbl_giaa "GI/AA:" pos:[8,120] width:32 height:16		
    	label lbl_lsm "LSM:" pos:[8,144] width:32 height:16    	
		label lbl_msi ":MSI" pos:[200,120] width:32 height:16
		label lbl_mrd ":MRD" pos:[200,144] width:32 height:16
		label lbl_pass_limit ":PLimit" pos:[200,168] width:32 height:16
    	label lbl_mat_override "Use Mtl. override:" pos:[8,168] width:96 height:16
    	label lbl_renderstamp_use "Use Render Stamp:" pos:[8,192] width:96 height:16

    	checkbox chk_override_mat_checkbox "" pos:[112,168] width:16 height:16 toolTip:"When checked, all scene materials will be overridden with a single specified material"
		
		checkbox chk_renderstamp_use_checkbox "" pos:[112,192] width:16 height:16 toolTip:"Use Render Stamp"

    	HyperLink scriptspotlink "3dwannab (◣_◢) on scriptspot.com" pos:[40,216] width:224 height:16 address:"http://www.scriptspot.com/users/3dwannab" color:(color 200 0 255) hovercolor:(color 255 255 255) visitedcolor:(color 0 0 0)
--------------------------------------------------------------------------------

    	on rolSub_1 open do
    	(
    		if getRenderType() == #region then
    		(
				chk_region.state = on
			)
			else
			chk_region.text = "Region OFF"
		
			if getRenderType() == #region then
			chk_region.text = "Region ON"
			else
			(
			)		

			if EditRenderRegion.IsEditable == true and EditRenderRegion.IsEditing == false then
			EditRenderRegion.EditRegion()
			
			if getRenderType() == #blowup then
    		(
				chk_blowup.state = on
			)
    		else
    		chk_blowup.text = "Blowup OFF"
    	
    		if getRenderType() == #blowup then
    		chk_blowup.text = "Blowup ON"
    		else
    		(
    		)		
    		
    		if renderDisplacements == true then
				(
				chk_displacement.state = on				
				chk_displacement.text = "Displace ON"
				)
				else
				(
				chk_displacement.text = "Displace OFF"
				)
			
			spn_output_width.value = renderWidth as integer
			spn_output_height.value = renderHeight as integer
    		
			if (matchPattern (renderers.current as string) pattern:"V_Ray_*") then
			if vr=renderers.current.options_displacement == true then
			(
			chk_displacement.state = true
			renderDisplacements = true
			)
			else
			(
			chk_displacement.state = false
			renderDisplacements = false
			vr=renderers.current.options_displacement = false
			)
			
			if (matchPattern (renderers.current as string) pattern:"Corona*") then
			if renderDisplacements == true then
 			chk_displacement.state = true
			else
			()

    		if (matchPattern (renderers.current as string) pattern:"Corona*") then
    		spn_giaa.value = renderers.current.shading_giToAaRatio
    		else spn_giaa.enabled = false
			
    		if (matchPattern (renderers.current as string) pattern:"Corona*") then
    		spn_lsm.value = renderers.current.lights_samplesMult
    		else spn_lsm.enabled = false
    		
    		if (matchPattern (renderers.current as string) pattern:"Corona*") then
    		spn_msi.value = renderers.current.shading_maxSampleIntensity
    		else spn_msi.enabled = false
    		
    		if (matchPattern (renderers.current as string) pattern:"Corona*") then
    		spn_mrd.value = renderers.current.shading_maxRayDepth
    		else spn_mrd.enabled = false
 
			
    		if (matchPattern (renderers.current as string) pattern:"Corona*") then
    		if renderers.current.mtlOverride_enabled == true then
    		chk_override_mat_checkbox.state = true
			else
    		()
	
    		if (matchPattern (renderers.current as string) pattern:"V_Ray_*") then
    		if renderers.current.options_overrideMtl_on == true then
    		chk_override_mat_checkbox.state = true
			else
    		()
			
    		if (matchPattern (renderers.current as string) pattern:"Corona*") then
    		spn_pass_limit.value = renderers.current.progressive_passLimit
    		else spn_pass_limit.enabled = false
			
			if (matchPattern (renderers.current as string) pattern:"Corona*") then
    		if renderers.current.renderstamp_use == true then
    		chk_renderstamp_use_checkbox.state = true
			else
    		()
	
    		if (matchPattern (renderers.current as string) pattern:"V_Ray_*") then
    		if renderers.current.system_frameStamp_on == true then
    		chk_renderstamp_use_checkbox.state = true
			else
    		()
	
    	)
		
    	on rolSub_1 rolledUp bState do
    	(
    	    if (bState == true) then
    	    (
    	        rolMainRR.height += rolSub_1.height
    	        rolMainRR.height += 4
    	    )
    	    else
    	    (
    	        rolMainRR.height -= rolSub_1.height
    	        rolMainRR.height -= 4
    	    )
    	)

--------------------------------------------------------------------------------- HELP WANTED ---------------------------------------------------------------------------------
		
		dotNetControl obj_dd "System.Windows.Forms.ComboBox" pos:[8,8] width:224 height:22		
		-- When the ComboBox selection is changed change do something
		fn dd_fill =
		(
			-- Collect the Cameras into an array
			camArray = for i in cameras where superclassof i == Camera collect i.name
			-- Clear the ComboBox list
			obj_dd.items.clear()
			-- Build a new ComboBox list using the view array
			
			
			--obj_dd.items.addRange (#("Choose"))
			--obj_dd.SelectedIndex = 1

			obj_dd.items.addrange camArray
			
		)
		on drop_roll open do
		(
			dd_fill()
			--Fill on open
		)
		on obj_dd DropDown do
		(
			--Fill on expanding the list
			dd_fill()
		)

		on obj_dd SelectedIndexChanged do
		(
			--Command to execute on selecting the entry
			select (getNodeByName obj_dd.text)
			viewport.setCamera (getNodeByName obj_dd.text)
		)
		
--------------------------------------------------------------------------------- HELP WANTED ---------------------------------------------------------------------------------
		
    	on chk_region changed state do
    	if state then
    		(
			chk_blowup.state = off
    		chk_region.text = "Region ON"
			chk_blowup.text = "Blowup OFF"
    		setRenderType #region
			if EditRenderRegion.IsEditable == true and EditRenderRegion.IsEditing == false then EditRenderRegion.EditRegion()
			EditRenderRegion.UpdateRegion()
    		)
    	else
    		(
			chk_region.text = "Region OFF"
    		setRenderType #view
			EditRenderRegion.UpdateRegion()
    		)

		on chk_blowup changed state do
    	if state then
    		(
			chk_region.state = off
    		chk_blowup.text = "Blowup ON"
			chk_region.text = "Region OFF"
    		setRenderType #blowup
			if EditRenderRegion.IsEditable == true and EditRenderRegion.IsEditing == false then EditRenderRegion.EditRegion()
			EditRenderRegion.UpdateRegion()
    		)
    	else
    		(
    		chk_blowup.text = "Blowup OFF"
    		setRenderType #view
			EditRenderRegion.UpdateRegion()
    		)

    	on chk_displacement changed state do
			if state then
				(
				renderDisplacements = true
				if (matchPattern (renderers.current as string) pattern:"V_Ray_*") then
				vr=renderers.current.options_displacement = true
				chk_displacement.text = "Displace ON"
				)
			else
				(
				renderDisplacements = false
				if (matchPattern (renderers.current as string) pattern:"V_Ray_*") then
				vr=renderers.current.options_displacement = false
				chk_displacement.text = "Displace OFF"
				)
			
		on spn_output_width changed val do
    	(
    		renderWidth = spn_output_width.value
    	)
		
		on spn_output_height changed val do
    	(
    		renderHeight = spn_output_height.value
    	)
	
		on btn_res_width_mul pressed do
    	(
    		res_width_mul_NEW_VALUE = ((spn_output_width.value * 2) as integer)
			spn_output_width.value = res_width_mul_NEW_VALUE
			renderWidth = spn_output_width.value
    	)
	
		on btn_res_width_mul rightclick do
    	(
    		res_width_mul_NEW_VALUE = ((spn_output_width.value / 2) as integer)
			spn_output_width.value = res_width_mul_NEW_VALUE
			renderWidth = spn_output_width.value
    	)
		
		on btn_res_height_mul pressed do
    	(
    		res_height_mul_NEW_VALUE = ((spn_output_height.value * 2) as integer)
			spn_output_height.value = res_height_mul_NEW_VALUE
			renderHeight = spn_output_height.value
    	)
		
		on btn_res_height_mul rightclick do
    	(
    		res_height_mul_NEW_VALUE = ((spn_output_height.value / 2) as integer)
			spn_output_height.value = res_height_mul_NEW_VALUE
			renderHeight = spn_output_height.value
    	)

		on btn_res_overall_mul pressed do
    	(
    		res_overall_height_mul_NEW_VALUE = ((spn_output_height.value * 2) as integer)
			spn_output_height.value = res_overall_height_mul_NEW_VALUE
    		res_overall_width_mul_NEW_VALUE = ((spn_output_width.value * 2) as integer)
			spn_output_width.value = res_overall_width_mul_NEW_VALUE
			renderWidth = spn_output_width.value
			renderHeight = spn_output_height.value
    	)
	
		on btn_res_overall_mul rightclick do
    	(
    		res_overall_height_mul_NEW_VALUE = ((spn_output_height.value / 2) as integer)
			spn_output_height.value = res_overall_height_mul_NEW_VALUE
    		res_overall_width_mul_NEW_VALUE = ((spn_output_width.value / 2) as integer)
			spn_output_width.value = res_overall_width_mul_NEW_VALUE
			renderWidth = spn_output_width.value
			renderHeight = spn_output_height.value
    	)

    	on btn_Render pressed do
    	(
    		if renderSceneDialog.isOpen() == true do renderSceneDialog.close()
			renderWidth = spn_output_width.value
			renderHeight = spn_output_height.value
    		max quick render	
    	)
		
    	on btn_render_setup_dialog pressed do
    	(
    		renderWidth = spn_output_width.value
			renderHeight = spn_output_height.value
			if renderSceneDialog.isOpen() == false do renderSceneDialog.open()
    	)
		
    	on btn_render_setup_dialog rightClick do
    	(
    		if renderSceneDialog.isOpen() == true do renderSceneDialog.close()
    	)
		
--------------------------------------------------------------------------------- HELP WANTED TO RIGHTCLICK TO DEFAULT ---------------------------------------------------------------------------------
		
		on spn_lsm rightclick do
		(
		print "btn_A was rightclicked"
		--spn_lsm_NEW_VALUE = ((2.0) as integer)
		--spn_lsm_NEW_VALUE = spn_lsm.value
		)	
--     	spinner spn_msi "" pos:[136,88] width:56 height:16 range:[0,1000,20] type:#float scale:0.01 toolTip:"Speed/Accuracy balance: Max sample intensity\n\nThe ratio between rendering performance and physical accuracy.\n\nLowering it will result in clamping of the reflection and refraction caustics brightness, significantly reducing noise at the expense of bias. Increasing this value will reduce amount of clamping but also increase amount of noise. Default value of 20 works well in most scenes.\n\nSetting this value to 0 enables special unbiased mode where no clamping will occur. This mode will however often introduce fireflies that may never converge when using Progressive or Bucket render engine.\n\nDEFAULT: 20.0"
--     	spinner spn_mrd "" pos:[136,112] width:56 height:16 range:[1,100,25] type:#integer scale:10 toolTip:"Speed/Accuracy balance: Max ray depth\n\nThe maximum possible number of light bounces.\n\nLowering this value slightly improves performance, increasing it slightly improves accuracy. The change in Corona is however very small compared to other renderer's, so keeping the default value is advised.\n\nDEFAULT: 25"
-- 	spinner spn_pass_limit "" pos:[136,136] width:56 height:16 range:[0,1000,50] type:#integer scale:10 toolTip:"Default 0 = Infinity\n\nThe number of passes after which the rendering will stop. Each pass performs one anti-aliasing sample per pixel and a variable amount of secondary samples set by the GI/AA balance parameter."

--------------------------------------------------------------------------------- HELP WANTED TO RIGHTCLICK TO DEFAULT ---------------------------------------------------------------------------------

		
    	on btn_update_ui pressed do
    	(
    		if renderSceneDialog.isOpen() == true do renderSceneDialog.close()
    		try (destroyDialog rolMainRR) catch()
    		local FileInRRScript = (GetDir #userscripts) + "\\3dwannab\\RegionRender\\RegionRender_V2.0_by_3dwannab.ms"
    		fileIn FileInRRScript
    	)
		
    	on btn_render_resume pressed do
    	(
    		if not (matchPattern (renderers.current as string) pattern:"Corona*") then
    		messagebox "Resume Render only available in Corona!!\n\nGet your act together son :P" title:"RegionRender V2.0 by 3dwannab (◣_◢)"
				else
				renderWidth = spn_output_width.value
				renderHeight = spn_output_height.value
				CoronaRenderer.CoronaFp.resumeRender()
    	)
		
    	on spn_giaa changed val do
    	(
    		renderers.current.shading_giToAaRatio = spn_giaa.value
    	)

		on spn_mrd changed val do
		(
    		renderers.current.shading_maxRayDepth = spn_mrd.value
    	)
		
    	on spn_lsm changed val do
    	(
    		renderers.current.lights_samplesMult = spn_lsm.value
    	)
	
		on chk_override_mat_checkbox changed State do
		(
			if not state then 
			(
				if (matchPattern (renderers.current as string) pattern:"V_Ray_*") then
					(
					chk_override_mat_checkbox.state == false
					renderers.current.options_overrideMtl_on = false
					)					
				if (matchPattern (renderers.current as string) pattern:"Corona*") then
					(
					chk_override_mat_checkbox.state == false
					renderers.current.mtlOverride_enabled = false
					)
			)
					else 
				(
					if (matchPattern (renderers.current as string) pattern:"V_Ray_*") then
						(
						chk_override_mat_checkbox.state == true
						renderers.current.options_overrideMtl_on = true
						)					
					if (matchPattern (renderers.current as string) pattern:"Corona*") then
						(
						chk_override_mat_checkbox.state == true
						renderers.current.mtlOverride_enabled = true
						)
				)
		)
		
    	on spn_msi changed val do
    	(
    		renderers.current.shading_maxSampleIntensity = spn_msi.value
    	)
		
    	on spn_pass_limit changed val do
    	(
    		renderers.current.progressive_passLimit = spn_pass_limit.value
    	)
	
		on chk_renderstamp_use_checkbox changed State do
		(
			if not state then 
			(
				if (matchPattern (renderers.current as string) pattern:"V_Ray_*") then
					(
					chk_renderstamp_use_checkbox.state == false
					renderers.current.system_frameStamp_on = false
					)					
				if (matchPattern (renderers.current as string) pattern:"Corona*") then
					(
					chk_renderstamp_use_checkbox.state == false
					renderers.current.renderstamp_use = false
					)
			)
				else 
			(
				if (matchPattern (renderers.current as string) pattern:"V_Ray_*") then
					(
					chk_renderstamp_use_checkbox.state == true
					renderers.current.system_frameStamp_on = true
					)					
				if (matchPattern (renderers.current as string) pattern:"Corona*") then
					(
					chk_renderstamp_use_checkbox.state == true
					renderers.current.renderstamp_use = true
					)
			)
		)
		
		on btn_about pressed do
    	(
    	messageBox "RegionRender V2.0 by 3dwannab (◣_◢)\n------------------------------------------------------------------------------------\n\nDev. by Stephen Sherry.\nVisit: http://www.scriptspot.com/users/3dwannab.\n\nFree for all use and / or modification.\n\nIf you modify the script, please mention my name, cheers. :)\n\n------------------------------------------------------------------------------------\n\nSUMMARY OF SCRIPT USAGE:\n\n● Self explanatory (see tooltips, just hoover over buttons).\n\n● There's right click functions, mainly the size of render output. Again FMI (see tooltips).\n\n------------------------------------------------------------------------------------\n\nNOTES:\n\n● Some functions may not work for VRay. The buttons/spinners will be grayed out if so.\n\n● Please enjoy this and always if you have any thing you want added, please contact me on my scriptspot page." title:"About RegionRender (◣_◢)" beep:false
		)

    )
--------------------------------------------------------------------------------
	on rolMainRR open do
	(
		addSubRollout scriptBin rolSub_1
	)
	
)
    DialogPos = execute (getIniSetting DialogIniFile "RegionRenderSaveDialogRoll" "Position")
    if DialogPos == OK do DialogPos = [75,75]
createDialog rolMainRR 248 268 DialogPos.x DialogPos.y style:#(#style_titlebar, #style_sysmenu, #style_toolwindow)